/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleClientOpenidUserinfoConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/4.69.1/docs/data-sources/google_client_openid_userinfo google_client_openid_userinfo}
*/
export declare class DataGoogleClientOpenidUserinfo extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_client_openid_userinfo";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/4.69.1/docs/data-sources/google_client_openid_userinfo google_client_openid_userinfo} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleClientOpenidUserinfoConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGoogleClientOpenidUserinfoConfig);
    get email(): string;
    get id(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
